/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.gui.widgets;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;
import org.visnow.vn.engine.core.ParameterName;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.gui.swingwrappers.UserActionListener;
import org.visnow.vn.gui.swingwrappers.UserEvent;

/**
 *
 * @author Marcin Szpak, University of Warsaw, ICM
 */
public class RunButton extends javax.swing.JPanel
{
    public enum RunState
    {
        RUN_ONCE, RUN_DYNAMICALLY, NO_RUN
    }

    private boolean allowAuto = true;

    private final Color backgroundDefault;
    private final Color backgroundHighlight = Color.YELLOW;

    /**
     * Creates new form RunButton
     */
    public RunButton()
    {
        initComponents();
        backgroundDefault = runButton.getBackground();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        autoCB = new javax.swing.JCheckBox();
        runButton = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        autoCB.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        autoCB.setText("Auto");
        autoCB.setBorder(null);
        autoCB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        autoCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                autoCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 2);
        add(autoCB, gridBagConstraints);

        runButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        runButton.setText("Run");
        runButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                runButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(runButton, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    public void setPendingIfNoAuto()
    {
        if (allowAuto && !autoCB.isSelected())
            runButton.setBackground(backgroundHighlight);
    }

    public void clearPending()
    {
        runButton.setBackground(backgroundDefault);
    }

    public void updatePendingState(boolean pending)
    {
        if (pending) setPendingIfNoAuto();
        else clearPending();
    }

    public void updateAutoState(RunState state)
    {
        if (state == RunState.RUN_DYNAMICALLY) {
            if (!allowAuto) throw new IllegalStateException("This button is not auto-allowed.");
            autoCB.setSelected(true);
        } else autoCB.setSelected(false);
        updateControls();
    }

    public boolean isAutoCB()
    {
        return autoCB.isSelected();
    }

    public void setAutoCB(boolean auto)
    {
        autoCB.setSelected(auto);
        //XXX: it wasn't here on purpose... Hmm
        updateControls();
    }

    @Override
    public void setEnabled(boolean enabled)
    {
        //jPanel enabled as a flag
        super.setEnabled(enabled);
        updateControls();
    }

    public boolean isAllowAuto()
    {
        return allowAuto;
    }

    public void setAllowAuto(boolean allowAuto)
    {
        this.allowAuto = allowAuto;
        updateControls();
    }

    private void updateControls()
    {
        autoCB.setVisible(allowAuto);
        runButton.setEnabled((!allowAuto || !autoCB.isSelected()) && super.isEnabled());
        autoCB.setEnabled(super.isEnabled());
        if (super.isEnabled() && allowAuto && autoCB.isSelected())
            clearPending();
    }

    private void runButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_runButtonActionPerformed
    {//GEN-HEADEREND:event_runButtonActionPerformed
        clearPending();
        fireUserAction(new UserEvent(this, RunState.RUN_ONCE));
    }//GEN-LAST:event_runButtonActionPerformed


    private void autoCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_autoCBActionPerformed
    {//GEN-HEADEREND:event_autoCBActionPerformed
        clearPending();
        updateControls();
        fireUserAction(new UserEvent(this, autoCB.isSelected() ? RunState.RUN_DYNAMICALLY : RunState.NO_RUN));
    }//GEN-LAST:event_autoCBActionPerformed

    private final List<UserActionListener> userActionListeners = new ArrayList<UserActionListener>();

    public void addUserActionListener(UserActionListener listener)
    {
        userActionListeners.add(listener);
    }

    public void removeUserActionListener(UserActionListener listener)
    {
        userActionListeners.remove(listener);
    }

    private void fireUserAction(UserEvent event)
    {
        for (UserActionListener listener : userActionListeners) {
            listener.userChangeAction(event);
            listener.userAction(event);
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox autoCB;
    private javax.swing.JButton runButton;
    // End of variables declaration//GEN-END:variables

    //XXX: this should be refactored to avoid overriding all these setters
    //the idea similar to protected synchronized protected void set(ParameterName[] names, Object[] values)
    /**
     * Makes this runButton a new proxy between client (GUI) code and targetProxy.
     * This is to auto-update run button pending state (glow state).
     * This is "thin" proxy - so parameters are redirected immediately to targetProxy, no caching or processing is involved.
     * <p>
     * @param targetProxy         target proxy to which all set/get calls will be redirected (typically target module logic parameterProxy).
     * @param thisButtonName      name of this button necessary to avoid pending state glow on button event (when switching from auto to manual state)
     *                            this plain proxy assume that runButton events go through one-parameter setter - set(signature, value).
     * <p>
     * @return new proxy which is a middleman between your code and targetProxy
     */
    public ParameterProxy getPlainProxy(final ParameterProxy targetProxy, ParameterName thisButtonName)
    {
        final String buttonName = thisButtonName.getName();

        return new ParameterProxy()
        {
            @Override
            public <T> T get(ParameterName<T> signature)
            {
                return targetProxy.get(signature);
            }

            @Override
            public <T> void set(ParameterName<T> signature, T value)
            {
                if (!signature.getName().equals(buttonName)) setPendingIfNoAuto();
                targetProxy.set(signature, value);
            }

            @Override
            public <T1, T2> void set(ParameterName<T1> signature1, T1 value1, ParameterName<T2> signature2, T2 value2)
            {
                setPendingIfNoAuto();
                targetProxy.set(signature1, value1, signature2, value2);
            }

            @Override
            public <T1, T2, T3> void set(ParameterName<T1> signature1, T1 value1, ParameterName<T2> signature2, T2 value2, ParameterName<T3> signature3, T3 value3)
            {
                setPendingIfNoAuto();
                targetProxy.set(signature1, value1, signature2, value2, signature3, value3);
            }

            @Override
            public <T1, T2, T3, T4> void set(ParameterName<T1> signature1, T1 value1, ParameterName<T2> signature2, T2 value2, ParameterName<T3> signature3, T3 value3, ParameterName<T4> signature4, T4 value4)
            {
                setPendingIfNoAuto();
                targetProxy.set(signature1, value1, signature2, value2, signature3, value3, signature4, value4);
            }

            @Override
            public <T1, T2, T3, T4> void set(ParameterName<T1> signature1, T1 value1, ParameterName<T2> signature2, T2 value2, ParameterName<T3> signature3, T3 value3, ParameterName<T4> signature4, T4 value4, Object... signatureAndValues)
            {
                setPendingIfNoAuto();
                targetProxy.set(signature1, value1, signature2, value2, signature3, value3, signature4, value4, signatureAndValues);
            }
        };
    }
}
